/********************************************************************/
/*	iCAM Common Source												*/
/********************************************************************/
#include "StdAfx.h"
#include "SVIComm.h"
#include "SVIPluginComm.h"

ULONG	gulHeight;

/********************************************************************/
/*	֐hcFGetExecHandle											*/
/*	֐́Fnh擾											*/
/*	@\TvFw肳ꂽs̃nh擾						*/
/*  ߂l  FFnh ُFNULL								*/
/********************************************************************/
CWnd* GetExecHandle(
					CString strClassName,	// [IN] NX
					CString strFileName )	// [IN] ^Cg
{
	// NAvP[Ṽgbvx̃EBhE̎擾
	CWnd*	pPrevWnd = CWnd::GetDesktopWindow()->GetWindow( GW_CHILD );

	char	findClass[MAX_256];	// EBhEENX
	char	findTitle[MAX_512];	// EBhEE^Cg

	while(pPrevWnd)
	{
		GetClassName(pPrevWnd->m_hWnd, findClass, sizeof( findClass ));
		pPrevWnd->GetWindowText( findTitle, sizeof( findTitle ));

		// NXƃ^CgrASVIViewł΁AbZ[W𑗕t
		if( (strcmp( findTitle, strFileName ) == 0) || (strcmp( findClass, strClassName ) == 0) )
		{
			return pPrevWnd;
		}
		//AvP[Ṽgbvx̃EBhE̎擾
		pPrevWnd = pPrevWnd->GetWindow( GW_HWNDNEXT );
	}

	return NULL;
}	// GetExecHandle End

/********************************************************************/
/*	֐hcFWinExecEx												*/
/*	֐́FAvP[Vs									*/
/*	@\TvFw肳ꂽAvP[Vs܂				*/
/*  ߂l  F:DEF_OK / ُ:DEF_ERR							*/
/********************************************************************/
int WinExecEx(
				LPCSTR	strFileName,	// [IN] R}hCւ̃|C^
				UINT	uCmdShow )		// [IN] EBhE̕\
{
	UINT	rc;
	CString	strMessage;

	// w肳ꂽt@C̎s
	rc	= WinExec( strFileName, uCmdShow );

	if( rc < 32 ) {
		// G[
		TRACE( "WinExec Error\n" );
		strMessage.Format( MSG_ERR_WINEXEC, strFileName );
		TRACE( strMessage );
		return DEF_ERR;
	}

	return DEF_OK;
}	// WinExecEx End

/********************************************************************/
/*	֐hcFSetTime												*/
/*	֐́FݎԂ̎擾										*/
/*	@\TvFݎԂ擾AʎԂZbg			*/
/*  ߂l  F														*/
/********************************************************************/
void SetTime( CString& strTime )
{
	SYSTEMTIME		SystemTime;

	GetLocalTime( &SystemTime );

	strTime.Format( "%02d_%02d_%02d_%02d_%02d_%02d_%03d",
							SystemTime.wYear % 100,
							SystemTime.wMonth,
							SystemTime.wDay,
							SystemTime.wHour,
							SystemTime.wMinute,
							SystemTime.wSecond,
							SystemTime.wMilliseconds );			// Second


}	// SetTime End

/********************************************************************/
/*	֐hcFConvInteger											*/
/*	֐́Ff[^ϊ											*/
/*	@\TvFf[^ϊ										*/
/*  ߂l  Fϊl											*/
/********************************************************************/
int ConvInteger( LPBYTE pData, int ReadSize )
{
	char	strBuff[MAX_32];

	memcpy( strBuff, pData, ReadSize );
	*( strBuff + ReadSize )	= NULL;

	return atoi( strBuff );
} // ConvInteger End

/********************************************************************/
/*	֐hcFConvDouble											*/
/*	֐́Ff[^ϊ											*/
/*	@\TvFf[^ϊ										*/
/*  ߂l  Fϊl											*/
/********************************************************************/
double ConvDouble( LPBYTE pData, int ReadSize )
{
	char	strBuff[MAX_32];

	memcpy( strBuff, pData, ReadSize );
	*( strBuff + ReadSize )	= NULL;

	return atof( strBuff );
} // ConvDouble End

/********************************************************************/
/*	֐hcFConvEndian											*/
/*	֐́FGfBAϊ										*/
/*	@\TvFGfBAϊ										*/
/*  ߂l  Fϊl											*/
/********************************************************************/
DWORD ConvEndian( LPBYTE pData, int ReadSize )
{
	DWORD	dwBuff;
	int		i;
	int		j;

	dwBuff	= 0;

	for( i = ReadSize - 1, j = 0 ; i >= 0 ; i--, j++ ) {
		dwBuff	+= *( pData + i ) << 8 * i;
	}

	return dwBuff;
} // ConvEndian End

/********************************************************************/
/*	֐hcFCalcDibSize											*/
/*	֐́F摜TCYvZ										*/
/*	@\TvF摜̃TCYvZ								*/
/*  ߂l  F摜TCY											*/
/********************************************************************/
DWORD CalcDibSize( DWORD dwXSize, DWORD dwYSize, double dZoomRate )
{
	DWORD	dwDibLength;

	// ؂o摜̃pfBO
	DWORD dwDataPadding	= CalcPadding( (DWORD)( (double)dwXSize * dZoomRate ) );

	// ؂o摜1CTCYisNZTCYj
	double dLineSize	= (double)dwXSize * dZoomRate * (double)RGB24LENGTH + (double)dwDataPadding;

	// ؂o摜TCYisNZTCYj
	dwDibLength	= (DWORD)( dLineSize * (double)dwYSize * dZoomRate );

	return dwDibLength;
} // CalcDibSize End


#ifdef	_DEF_LOGWRT
char	LOGstr[512];
void	LOGwrt( char *str )
{
static	FILE*	LOGfp	= NULL;
	char	LOGfile[MAX_128];		// Ot@C

	char	szExecPath[ MAX_FILEPATH ];
	char	szDrive	[ MAX_16 ];
	char	szDir	[ MAX_FILEPATH ];
	char	szFName	[ MAX_FILEPATH ];

	time_t	clock;
	tm		tmbuf;
	char	datetime[MAX_512];
	CString	strFile;

	clock	= time( 0 );
	localtime_s( &tmbuf, &clock );
	sprintf_s( datetime, 512, "%04d/%02d/%02d %02d:%02d:%02d",
		tmbuf.tm_year + 1900,
		tmbuf.tm_mon + 1,
		tmbuf.tm_mday,
		tmbuf.tm_hour,
		tmbuf.tm_min,
		tmbuf.tm_sec );

	::GetModuleFileName( AfxGetInstanceHandle(), szExecPath, MAX_FILEPATH );
	_splitpath_s( szExecPath, szDrive, MAX_16, szDir, MAX_FILEPATH, szFName, MAX_FILEPATH, NULL, 0 );

	sprintf_s( LOGfile, 128, "%s%s\\%s.log", szDrive, szDir, szFName );
	if( LOGfp == NULL )
	{
		fopen_s( &LOGfp, LOGfile, "w" );
	}
	else
	{
		fopen_s( &LOGfp, LOGfile, "r+" );
		if ( LOGfp == NULL )
		{
			fopen_s( &LOGfp, LOGfile, "w" );
			if ( LOGfp == NULL ) return;
		}
	}

	fseek( LOGfp, 0, SEEK_END );

	if	( LOGfp == NULL ) {
		return;
	}

	fprintf( LOGfp, "%s %s", datetime, str );
	fclose( LOGfp );
	return;
}
#endif		// _DEF_LOGWRT
