#ifndef __CRITICALSECTION_H__
#define __CRITICALSECTION_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CSync
{
public:
	virtual void lock() = 0;
	virtual void unlock() = 0;
};


class CLock
{
public:
	inline CLock(CSync &s) : sync(s)
		{sync.lock();}
	inline ~CLock()
		{sync.unlock();}
private:
	CSync &sync;
};


#include <Windows.h>


class CCriticalSection : public CSync
{
public:
	CCriticalSection()
		{::InitializeCriticalSection(&cs);}
	~CCriticalSection()
		{::DeleteCriticalSection(&cs);}
	virtual void lock()
		{::EnterCriticalSection(&cs);}
	virtual void unlock()
		{::LeaveCriticalSection(&cs);}
private:
	CRITICAL_SECTION cs;
};


#endif // __CRITICALSECTION_H__
