// FrameDataControl.cpp: CFrameDataControl NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SVIMon.h"
#include "FrameDataControl.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//#define log 1

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CFrameDataControl::CFrameDataControl()
{
	for(int i=0; i<ViewBuffNum; i++)
	{
		//t[̃Xe[^X
		FrameStatus[i] = NoData;
	}

#if 1 // 2005.06.03 Kashiwagi V3.10 \obt@̊i[ԂԍŊǗ
	FnoW = FnoR = FnoS = 0;
#endif

}

CFrameDataControl::~CFrameDataControl()
{
}

//bNĂȂݗpt[擾܂B
CFrameData* CFrameDataControl::getWriteFrameDataAndLock()
{
	CSingleLock lock(&CriticalSection,TRUE);

#if 1 // 2005.06.03 Kashiwagi V3.10 \obt@̊i[ԂԍŊǗ

#ifdef log // 2005.06.01 Kashiwagi debug
	LOGWRT( ( LOGstr, 512, "getWriteFrameDataAndLock w:%d r:%d s:%d sts(%d,%d,%d)\n", FnoW, FnoR, FnoS, FrameStatus[0], FrameStatus[1], FrameStatus[2]) );
#endif

	if(FrameStatus[FnoW] == NoData || FrameStatus[FnoW] == ViewEndFrame)
	{
		FrameStatus[FnoW]=WriteLockedFrame;
		return &FrameData[FnoW];
	}

#else

	//bNς݃t[`FbN
	UnLockWriteFrameData(false);//bNς݂̏݃t[΃AbN

	for(int i=0; i<ViewBuffNum; i++)
	{
		if(FrameStatus[i] == NoData || FrameStatus[i] == ViewEndFrame)
		{
			FrameStatus[i]=WriteLockedFrame;
			return &FrameData[i];
		}
	}

#endif

	return NULL;
}

//bNݗpt[AbN܂(̓t[f[^݂̏ɐj
void CFrameDataControl::UnLockWriteFrameData(bool SuccessWriteFrameData)
{
	CSingleLock lock(&CriticalSection,TRUE);

#if 1 // 2005.06.03 Kashiwagi V3.10 \obt@̊i[ԂԍŊǗ
#ifdef log // 2005.06.01 Kashiwagi debug
	LOGWRT( ( LOGstr, 512, "UnLockWriteFrameData     w:%d r:%d s:%d sts(%d,%d,%d) f:%d\n", FnoW, FnoR, FnoS, FrameStatus[0], FrameStatus[1], FrameStatus[2], SuccessWriteFrameData) );
#endif

	if(SuccessWriteFrameData == true)
	{
		FrameStatus[FnoW] = NewFrameData;
		if((FnoW+1) == ViewBuffNum)
		{
			FnoW = 0;
		}
		else
		{
			FnoW++;
		}
	}
	else
	{
		FrameStatus[FnoW] = NoData;
		if((FnoW+1) == ViewBuffNum)
		{
			FnoW = 0;
		}
		else
		{
			FnoW++;
		}
	}

#else

	for(int i=0; i<ViewBuffNum; i++)
	{
		if(FrameStatus[i] == WriteLockedFrame)
		{
			if(SuccessWriteFrameData == true)
			{
				FrameStatus[i] = NewFrameData;
			}
			else
			{
				FrameStatus[i] = NoData;
			}
		}
	}

#endif

}

//݂\pt[bN擾܂BiꍇNULLԂ܂j
CFrameData* CFrameDataControl::getViewFrameDataAndLock()
{
//	CSingleLock lock(&CriticalSection,TRUE);

#if 1 // 2005.06.03 Kashiwagi V3.10 \obt@̊i[ԂԍŊǗ

#ifdef log // 2005.06.01 Kashiwagi debug
	LOGWRT( ( LOGstr, 512, "getViewFrameDataAndLock  w:%d r:%d s:%d sts(%d,%d,%d)\n", FnoW, FnoR, FnoS, FrameStatus[0], FrameStatus[1], FrameStatus[2]) );
#endif

	if(FrameStatus[FnoR] == NewFrameData)
	{
		CSingleLock lock(&CriticalSection,TRUE);
		FrameStatus[FnoR]=ViewLockedFrame;
		return &FrameData[FnoR];
	}

#else

	//bNς݃t[`FbN
	UnLockViewFrameData();//bNς݂̕\t[΃AbN

	for(int i=0; i<ViewBuffNum; i++)
	{
		if(FrameStatus[i] == NewFrameData)
		{
			FrameStatus[i]=ViewLockedFrame;
			return &FrameData[i];
		}
	}

#endif

	return NULL;
}

//\pt[̃bN
void CFrameDataControl::UnLockViewFrameData()
{
	CSingleLock lock(&CriticalSection,TRUE);

#if 1 // 2005.06.03 Kashiwagi V3.10 \obt@̊i[ԂԍŊǗ
#ifdef log // 2005.06.01 Kashiwagi debug
	LOGWRT( ( LOGstr, 512, "UnLockViewFrameData      w:%d r:%d s:%d sts(%d,%d,%d)\n", FnoW, FnoR, FnoS, FrameStatus[0], FrameStatus[1], FrameStatus[2]) );
#endif

	FrameStatus[FnoR] = ViewEndFrame;
	if((FnoR+1) == ViewBuffNum)
	{
		FnoR = 0;
	}
	else
	{
		FnoR++;
	}

#else

	for(int i=0; i<ViewBuffNum; i++)
	{
		if(FrameStatus[i] == ViewLockedFrame)
		{
#if 1 // 2005.06.01 Kashiwagi V3.09 ߋɕ\t[͔pƂ
			FrameStatus[i] = ViewEndFrame;
			if(i==0){
				if(FrameStatus[1] == ViewEndFrame) FrameStatus[1] = NoData;
				if(FrameStatus[2] == ViewEndFrame) FrameStatus[2] = NoData;
			}else if(i==1){
				if(FrameStatus[0] == ViewEndFrame) FrameStatus[0] = NoData;
				if(FrameStatus[2] == ViewEndFrame) FrameStatus[2] = NoData;
			}else{
				if(FrameStatus[0] == ViewEndFrame) FrameStatus[0] = NoData;
				if(FrameStatus[1] == ViewEndFrame) FrameStatus[1] = NoData;
			}
#else
			FrameStatus[i] = ViewEndFrame;
#endif
		}
	}

#endif

}

//\͕\t[擾܂BbN܂iꍇNULLԂ܂j
CFrameData* CFrameDataControl::getViewEndFrame()
{
	//QƐpȂ̂ŃbNȂ
	//CSingleLock lock(&CriticalSection,TRUE);

#if 1 // 2005.06.03 Kashiwagi V3.10 \obt@̊i[ԂԍŊǗ

#ifdef log // 2005.06.01 Kashiwagi debug
	LOGWRT( ( LOGstr, 512, "getViewEndFrame          w:%d r:%d s:%d sts(%d,%d,%d)\n", FnoW, FnoR, FnoS, FrameStatus[0], FrameStatus[1], FrameStatus[2]) );
#endif

	if(FnoR == 0)
	{
		if(FrameStatus[ViewBuffNum-1] == ViewEndFrame)
		{
			return &FrameData[ViewBuffNum-1];
		}
	}
	else
	{
		if(FrameStatus[FnoR-1] == ViewEndFrame)
		{
			return &FrameData[FnoR-1];
		}
	}

#else

	//\̃t[΂D
	for(int i=0; i<ViewBuffNum; i++)
	{
		if(FrameStatus[i] == ViewLockedFrame)
		{
			return &FrameData[i];
		}
	}

	//\t[Ε\t[
	for(i=0; i<ViewBuffNum; i++)
	{
		if(FrameStatus[i] == ViewEndFrame)
		{
			return &FrameData[i];
		}
	}

	//LQΕ\Ot[
	for(i=0; i<ViewBuffNum; i++)
	{
		if(FrameStatus[i] == NewFrameData)
		{
			return &FrameData[i];
		}
	}

#endif

	return NULL;
}
//\͕\t[擾܂BbN܂iꍇNULLԂ܂j
CFrameData* CFrameDataControl::getViewEndFrameAndLock()
{
	CSingleLock lock(&CriticalSection,TRUE);

#if 1 // 2005.06.03 Kashiwagi V3.10 \obt@̊i[ԂԍŊǗ

#ifdef log // 2005.06.01 Kashiwagi debug
	LOGWRT( ( LOGstr, 512, "getViewEndFrameAndLock   w:%d r:%d s:%d sts(%d,%d,%d)\n", FnoW, FnoR, FnoS, FrameStatus[0], FrameStatus[1], FrameStatus[2]) );
#endif

	if(FnoR == 0)
	{
		if(FrameStatus[ViewBuffNum-1] == ViewEndFrame)
		{
			FrameStatus[ViewBuffNum-1] = WorkLockedFrame;
			FnoS = ViewBuffNum-1;
			return &FrameData[ViewBuffNum-1];
		}
	}
	else
	{
		if(FrameStatus[FnoR-1] == ViewEndFrame)
		{
			FrameStatus[FnoR-1] = WorkLockedFrame;
			FnoS = FnoR-1;
			return &FrameData[FnoR-1];
		}
	}

#else

	//\t[
	for(int i=0; i<ViewBuffNum; i++)
	{
		if(FrameStatus[i] == ViewEndFrame)
		{
			FrameStatus[i] = WorkLockedFrame;
			return &FrameData[i];
		}
	}

	//LΕ\Ot[
	for(i=0; i<ViewBuffNum; i++)
	{
		if(FrameStatus[i] == NewFrameData)
		{
			FrameStatus[i] = WorkLockedFrame;
			return &FrameData[i];
		}
	}

#endif

	return NULL;
}

//\͕\t[AbN܂
void CFrameDataControl::UnLockViewEndFrame()
{
	CSingleLock lock(&CriticalSection,TRUE);

#if 1 // 2005.06.03 Kashiwagi V3.10 \obt@̊i[ԂԍŊǗ

#ifdef log // 2005.06.01 Kashiwagi debug
	LOGWRT( ( LOGstr, 512, "UnLockViewEndFrame       w:%d r:%d s:%d sts(%d,%d,%d)\n", FnoW, FnoR, FnoS, FrameStatus[0], FrameStatus[1], FrameStatus[2]) );
#endif
	FrameStatus[FnoS] = ViewEndFrame;

#else

	//LΕ\Ot[
	for(int i=0; i<ViewBuffNum; i++)
	{
		if(FrameStatus[i] == WorkLockedFrame)
		{
			FrameStatus[i] = ViewEndFrame;
		}
	}

#endif

}
