// SviUsbControl.cpp: CSviUsbControl NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SVIMon.h"
#include "SviUsbControl.h"
#include "SVIOptions.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CSviUsbControl::CSviUsbControl()
{
	//oϐ
	RC=0;
	pReceiveBuff = NULL;

	// SVICu[
	SVIUSB20_Init();

	// ڑSVI-03{[h擾
	ScanBoard();

}

CSviUsbControl::~CSviUsbControl()
{
	freeMem();
	//SVIhCoEN[Y
	SVIUSB20_Close(SVIUSB20_APP_WHO_REC);
	//SVI{[hI
	SVIUSB20_DeviceRelease();
	//SVICu[I
	SVIUSB20_End();
}
//G[R[h擾܂BiG[R[h͏܂B)
DWORD CSviUsbControl::getLastError(void)
{
	DWORD outputRC = RC;
	RC = 0;
	return outputRC;
}

//G[R[h𕶎ɕϊ܂B
CString CSviUsbControl::getLastErrorString(DWORD errorcode)
{
	CString outputString;
	switch(errorcode)
	{
	case SVIUSB20_RET_NORMAL:
		outputString = "I";
		break;
	case SVIUSB20_RET_ERROR_DEVOPEN: 
		outputString = "SVIpUSB2.0hCoI[vł܂";
		break;
	case SVIUSB20_RET_ERROR_MULTIOPEN: 
		outputString = "AvP[V͓dɃI[vł܂";
		break;
	case SVIUSB20_RET_ERROR_PARAMETER: 
		outputString = "ɊԈႢ܂";
		break;
	case SVIUSB20_RET_ERROR_NOOPEN: 
		outputString = "hCoI[vĂ܂B";
		break;
	case SVIUSB20_RET_ERROR_COM:
		outputString = "SVIUSB20_RET_ERROR_COM";
		break;
	case SVIUSB20_RET_ERROR_NOIDLE:
		outputString = "SVIUSB20_RET_ERROR_NOIDLE";
		break;
	case SVIUSB20_RET_ERROR_FMUPDATE_T:
		outputString = "SVIUSB20_RET_ERROR_FMUPDATE_T";
		break;
	case SVIUSB20_RET_ERROR_FPUPDATE_T:
		outputString = "SVIUSB20_RET_ERROR_FPUPDATE_T";
		break;
	case SVIUSB20_RET_ERROR_GSTS2_T:
		outputString = "SVIUSB20_RET_ERROR_GSTS2_T";
		break;
	case SVIUSB20_RET_ERROR_MDATA_T:
		outputString = "SVIUSB20_RET_ERROR_MDATA_T";
		break;
	case SVIUSB20_RET_ERROR_SVI:
		outputString = "SVIUSB20_RET_ERROR_SVI";
		break;

	default:
		outputString.Format("Win32APIG[F%x",errorcode);
		break;
	}

	return outputString;
}

//G[`FbNPiprivate)
bool CSviUsbControl::checkLastError(void)
{
	if(RC != SVIUSB20_RET_NORMAL)
	{
		TRACE(getLastErrorString(RC));
		LOGWRT( ( LOGstr, 512, "checkLastError %s\n", getLastErrorString(RC) ) );
		return false;
	}
	return true;
}

//SVIhCoI[v܂
bool CSviUsbControl::open()
{
	CSingleLock lock(&cs,TRUE);

	//R[fBO[hŃI[v
	RC = SVIUSB20_Open(SVIUSB20_APP_WHO_REC);
	return checkLastError();
}

//SVIn[hEFA܂
bool CSviUsbControl::DeviceReset()
{
	CSingleLock lock(&cs,TRUE);

	//SVIZbg
	RC = SVIUSB20_DeviceReset();
	return checkLastError();
}

//SVIXe[^XXV܂(onlyBaseStatus : {Xe[^X̂ݍXVj
bool CSviUsbControl::refreshStatus(bool onlyBaseStatus)
{
	CSingleLock lock(&cs,TRUE);

	if(onlyBaseStatus == true)
	{
		//Xe[^X擾
		ULONG workStatus;
		RC = SVIUSB20_GetStatus2(&workStatus);
		// ERROR_CRCoXZbg𔭍s
		if((RC & 0xffffff) == ERROR_CRC){
			LOGWRT( ( LOGstr, 512, "refreshStatus : BusReset Executed\n" ) );
			RC = SVIUSB20_BusReset();
			LOGWRT( ( LOGstr, 512, "refreshStatus : Retry GetStatus2\n" ) );
			RC = SVIUSB20_GetStatus2(&workStatus);
		}
		//Xe[^XXV
		SviStatus.setBaseStatus(workStatus);
		if(checkLastError() == false)
		{
			LOGWRT( ( LOGstr, 512, "refreshStatus : GetStatus2[0x%08X] ulBasicStatus[0x%08X]\n", RC, workStatus ) );
			return false;
		}
	}
	else
	{
		GET_STATUS workStatus;
		//ڍ׃Xe[^X擾
		RC = SVIUSB20_GetStatus(&workStatus);
		// ERROR_CRCoXZbg𔭍s
		if((RC & 0xffffff) == ERROR_CRC){
			LOGWRT( ( LOGstr, 512, "refreshStatus : BusReset Executed\n" ) );
			RC = SVIUSB20_BusReset();
			LOGWRT( ( LOGstr, 512, "refreshStatus : Retry GetStatus\n" ) );
			RC = SVIUSB20_GetStatus(&workStatus);
		}
		//Xe[^XXV
		SviStatus.setStatus(workStatus);
		if(checkLastError() == false)
		{
			LOGWRT( ( LOGstr, 512, "refreshStatus : GetStatus[0x%08X] ulBasicStatus[0x%08X]\n", RC, workStatus.ulBasicStatus ) );
			return false;
		}
	}

	return true;
}

//SVIn[hEGAɐݒʒm܂
bool CSviUsbControl::setParam(bool bMonMode, int iPicType) // 2005.12.27
{
	CSingleLock lock(&cs,TRUE);

	//SVIn[hEGAɐݒʒm
	SET_PARAM param;
	param.ulParamBitFlag	= SVIUSB20_SETPARAM_BIT6 | SVIUSB20_SETPARAM_BIT0; // j^O[hA摜w
	param.ulMonMode			= (ULONG)bMonMode; // j^O[hi0 : ޯ̧A1 : ݸޯ̧j
	if(iPicType == PicYUV || iPicType == PicRGB || iPicType == PicYUY2 || iPicType == PicVYUY || iPicType == PicYVYU){
		param.ulPixelInfo	= 0x2; // bit0-1:1f̐Abit2:1f̃rbg(0:8,1:16j
	}else if(iPicType == PicY){
		param.ulPixelInfo	= 0x1; // bit0-1:1f̐Abit2:1f̃rbg(0:8,1:16j
	}else if(iPicType == PicY10 || iPicType == PicY12){
		param.ulPixelInfo	= 0x5; // bit0-1:1f̐Abit2:1f̃rbg(0:8,1:16j
	}else if(iPicType == PicUYVY16 || iPicType == PicVYUY16){
		param.ulPixelInfo	= 0x6; // bit0-1:1f̐Abit2:1f̃rbg(0:8,1:16j
	}else if(iPicType == PicYUY216){
		param.ulPixelInfo	= 0x6; // bit0-1:1f̐Abit2:1f̃rbg(0:8,1:16j
	}
	RC = SVIUSB20_SetParam(&param);
	return checkLastError();
}

//j^OJn܂
bool CSviUsbControl::startMonitoring(int left,int top, int width, int height)
{

	//̃`FbN(ƍ͋łȂ΂܂j
	if(width%2 != 0)
	{
		TRACE("startMonitoring : ƍ͋łȂ΂܂\r\n");
		LOGWRT( ( LOGstr, 512, "startMonitoring : Width should be an even number\n" ) );
		return false;
	}
	//AChԂmF
	int i = 0;
	while( 1 ) {
		// Xe[^X擾s܂
		if( refreshStatus(false) == false ) {
			LOGWRT( ( LOGstr, 512, "MonitoringStart A camera cannot be initialized.\n" ) );
			return FALSE;
		}
		if(SviStatus.IsIdle() == false) {
			LOGWRT( ( LOGstr, 512, "SVI not idle : DeviceReset Executed & Rety GetStatus\n" ) );
			DeviceReset();
			goto retry;
		}
		if( SviStatus.getOriginalWidth() > 0 && SviStatus.getOriginalHeight() > 0 ) {
			break;
		}
retry:
		if(m_iMonTimeout == 0) break;
		if( i++ > 50 ) {
			// foCXN[Y
			LOGWRT( ( LOGstr, 512, "Monitoring VHsync not start\n" ) );
			return FALSE;
		}
		Sleep( 100 );
	}

	CSingleLock lock(&cs,TRUE);


	//j^OX^[g
	MONITOR_PARAM pram;
	pram.ulCutout_x = left;
	pram.ulCutout_y = top;
	pram.ulCutout_w = width;
	pram.ulCutout_h = height;
	RC = SVIUSB20_MonStart(&pram);
	if( RC == SVI_STS_BUSY ){
		LOGWRT( ( LOGstr, 512, "Call SVIDveiceBusReset\n" ) );
		if( SVIUSB20_BusReset() != SVIUSB20_RET_NORMAL ) {	// oXZbg
			LOGWRT( ( LOGstr, 512, "SVIDeviceCloseNoLock BusResetErr\n" ) );
			return false;
		}
		SVIUSB20_Close(SVIUSB20_APP_WHO_REC);
		SVIUSB20_Open(SVIUSB20_APP_WHO_REC);
	}
	return checkLastError();

}

//j^O~܂
bool CSviUsbControl::stopMonitoring(PictureType PicType)
{
	CFrameData dumy;//ۗt[pp_~[
	
	{
		CSingleLock lock(&cs,TRUE);
		setVsyncSignal(1);
		setVsyncSignal(0);
		//j^O~
		RC = SVIUSB20_MonStop();
	}
	refreshStatus(true);
	if(PicType == PicY10) dumy.setY10Mode();
	else if(PicType == PicY12) dumy.setY12Mode();
	else if(PicType == PicUYVY16) dumy.setUYVY16Mode();
	else if(PicType == PicVYUY16) dumy.setVYUY16Mode();
	else if(PicType == PicYUY216) dumy.setYUY216Mode();
		dumy.setDispRawMode(0);

	while(SviStatus.IsFramePending() == true)//ۗt[`FbN
	{
		//ۗt[n[hEGAɎcĂ̂ŁAׂĎ荞݁Ap܂B
		if( getMonitoringFrameData(&dumy) == false )
		{
			RC = SVIUSB20_DeviceReset();
		}
		refreshStatus(true);
	}
	return checkLastError();

}

//ۗt[f[^݂邩`FbN܂
bool CSviUsbControl::IsFramePending(void)
{
	//ۗt[f[^݂邩`FbN
	RC = refreshStatus(true);
	if(checkLastError() == false)
	{
		return false;
	}
	return SviStatus.IsFramePending();
}

//j^Ot[f[^擾܂
bool CSviUsbControl::getMonitoringFrameData(CFrameData* frameData)
{
	CSingleLock lock(&cs,TRUE);

	//t[wb_擾
	MON_HEADER frameHeader;
	RC = SVIUSB20_MonGetHeader(&frameHeader);
	if(checkLastError() == false)
	{
		LOGWRT( ( LOGstr, 512, "getMonitoringFrameData : j^Owb_[擾G[\n" ) );
		return false;
	}

	// 2005.12.21 V3.32 摜̏ꍇ͕sf[^ƂăG[I
	if((frameHeader.ulMonSizeW & 0x1))
	{
		LOGWRT( ( LOGstr, 512, "getMonitoringFrameData : j^Of[^sG[\n" ) );
		return false;
	}

	frameData->setFrameHeader(&frameHeader);//t[wb_[Zbg

	ULONG readSize;//ǂݍ݃TCY

	//t[f[^擾
	RC = SVIUSB20_MonGetFrame(frameData->getImageDataField(), frameData->getImageSize(), &readSize);
	if(checkLastError() == false)
	{
		LOGWRT( ( LOGstr, 512, "getMonitoringFrameData : j^Ot[擾G[\n" ) );
		return false;
	}
	// InformationCutout SizeCutoutSettingƓl\Ă邽
	// Monitoring wb_̃TCYݒ肷悤ɏC
	SviStatus.setMonheader(frameHeader);
	return true;

}

//SVIhCoN[Y܂
void CSviUsbControl::close()
{
	CSingleLock lock(&cs,TRUE);

	//R[fBO[hŃI[v
	SVIUSB20_Close(SVIUSB20_APP_WHO_REC);
}

//VIF8bit16bitw肷
bool CSviUsbControl::setBitCounts(int bits)
{
	//FPGAAbvf[g
	CSingleLock lock(&cs,TRUE);
	unsigned char cbuf[4];
	ULONG ulSlaveAdr = 0x8; // SVI-board I2C register slave address
	cbuf[0] = 0x0; // Sub address
	RC = SVIUSB20_I2COneBlockWrite(ulSlaveAdr,	0x1, 0x0, cbuf);
	if(checkLastError() == false) return false;
	RC = SVIUSB20_I2COneBlockRead (ulSlaveAdr, 0x1, 0x0, &cbuf[1]);
	if(checkLastError() == false) return false;
	if(bits == 8){
		cbuf[1] &= 0xbf; // bit6 - 0:8bit 1:16bit
	}else{
		cbuf[1] |= 0x40; // bit6 - 0:8bit 1:16bit
	}
	RC = SVIUSB20_I2COneBlockWrite(ulSlaveAdr,	0x2, 0x0, cbuf);
	return checkLastError();
}

// M[hw肷
bool CSviUsbControl::setSyncMode(bool bSyncMode)
{
	CSingleLock lock(&cs,TRUE);
	unsigned char cbuf[4];
	ULONG ulSlaveAdr = 0x8; // SVI-board I2C register slave address
	cbuf[0] = 0x20; // Sub address
	RC = SVIUSB20_I2COneBlockWrite(ulSlaveAdr,	0x1, 0x0, cbuf);
	if(checkLastError() == false) return false;
	RC = SVIUSB20_I2COneBlockRead (ulSlaveAdr, 0x1, 0x0, &cbuf[1]);
	if(checkLastError() == false) return false;
	if(bSyncMode == false){
		cbuf[1] &= 0xfd; // bit1 - 0:Low Active 1:High Active
	}else{
		cbuf[1] |= 0x2;  // bit6 - 0:1 - 0:Low Active 1:High Active
	}
	RC = SVIUSB20_I2COneBlockWrite(ulSlaveAdr,	0x2, 0x0, cbuf);
	return checkLastError();
}

// PixClk荞ݐݒw肷
bool CSviUsbControl::setEdgeMode(bool bEdgeMode)
{
	CSingleLock lock(&cs,TRUE);
	unsigned char cbuf[4];
	ULONG ulSlaveAdr = 0x8; // SVI-board I2C register slave address
	cbuf[0] = 0x2e; // Sub address
	RC = SVIUSB20_I2COneBlockWrite(ulSlaveAdr,	0x1, 0x0, cbuf);
	if(checkLastError() == false) return false;
	RC = SVIUSB20_I2COneBlockRead (ulSlaveAdr, 0x1, 0x0, &cbuf[1]);
	if(checkLastError() == false) return false;
	if(bEdgeMode == false){
		cbuf[1] |= 0x1; // bit0 - 0: 1:
	}else{
		cbuf[1] &= 0xfe; // bit0 - 0: 1:
	}
	RC = SVIUSB20_I2COneBlockWrite(ulSlaveAdr,	0x2, 0x0, cbuf);
	return checkLastError();
}

// {[hԍiSVI-??jAPLLݒg擾
bool CSviUsbControl::getBoardInfo(int *iBoardVer, int *iPllData)
{
	CSingleLock lock(&cs,TRUE);
	unsigned char cbuf[6];
	ULONG ulSlaveAdr = 0x8; // SVI-board I2C register slave address
	cbuf[0] = 0x9; // Sub address
	RC = SVIUSB20_I2COneBlockWrite(ulSlaveAdr,	0x1, 0x0, cbuf);
	if(checkLastError() == false) return false;
	RC = SVIUSB20_I2COneBlockRead (ulSlaveAdr, 0x6, 0x0, cbuf);
	if(checkLastError() == false) return false;
	*iBoardVer = (int)cbuf[0] & 0xff;
	*iPllData  = ((((int)cbuf[4]<<24)&0xff000000) | (((int)cbuf[3]<<16)&0xff0000) | (((int)cbuf[2]<<8)&0xff00) | ((int)cbuf[1]&0xff));
	return true;
}

//VIF8bit16bitw肷
void CSviUsbControl::setVsyncSignal(int iMode)
{
	//FPGAAbvf[g
	CSingleLock lock(&cs,TRUE);
	unsigned char cbuf[4];
	ULONG ulSlaveAdr = 0x8; // SVI-board I2C register slave address
	cbuf[0] = 0x0; // Sub address
	RC = SVIUSB20_I2COneBlockWrite(ulSlaveAdr,	0x1, 0x0, cbuf);
	if(checkLastError() == false) return;
	RC = SVIUSB20_I2COneBlockRead (ulSlaveAdr, 0x1, 0x0, &cbuf[1]);
	if(checkLastError() == false) return;
	if(iMode == 0){ // OFF
		cbuf[1] &= 0xfd; // bit1 - 0:VSYNC-OFF 1:VSYNC-ON
	}else{
		cbuf[1] |= 0x02; // bit1 - 0:VSYNC-OFF 1:VSYNC-ON
	}
	RC = SVIUSB20_I2COneBlockWrite(ulSlaveAdr,	0x2, 0x0, cbuf);
}

ULONG CSviUsbControl::GetBoardNum()
{
	return ulBoardNum;
}
ULONG CSviUsbControl::GetDeviceID(int no)
{
	return ulBoardInfo[no];
}
DWORD CSviUsbControl::ScanBoard()
{
	// ڑSVI-03{[h擾
	ulBoardNum = 0;
	memset(ulBoardInfo,0x0,sizeof(ULONG)*4);
	return SVIUSB20_EnumDevice(SVIUSB20_APP_WHO_REC,&ulBoardNum,ulBoardInfo);
}
void CSviUsbControl::SetSelBoardNo(int no)
{
	ulSelBoardNo = ulBoardInfo[no];
	SVIUSB20_DeviceSelect(ulSelBoardNo);
}

int CSviUsbControl::GetSelBoardNo()
{
	return ((ulSelBoardNo >> 16) & 0xffff);
}
